Subject: RE: [SIP] Further editorial nit in the bis draft

From: Jonathan Rosenberg <[email-masked]>
Date: Fri, 27 Apr 2001 03:38:03 -0400

-----Original Message-----
>From: Sean Olson (EUS) [mailto:[email-masked]]
>Sent: Thursday, April 26, 2001 1:07 PM
>To: 'Vijay Gurbani'; Christer Holmberg (LMF)
>Cc: Jonathan Rosenberg; 'Drage, Keith (Keith)'; 'Henning G. Schulzrinne';
[email-masked]
>labs.com'
>Subject: RE: [SIP] Further editorial nit in the bis draft
>
>
>
>
>>Oh, that brings up an interesting point:   If a stateful proxy 
>>forked and one of the branches reached a stateless downstream 
>>server, when 
>>the statful proxy gets a CANCEL, it will propogate the CANCEL 
>>to the state- 
>>less downstream proxy.  What do statless proxies do on getting 
>>a CANCEL?  
>>Since they do not have state associated with the INVITE they received 
>>earlier, how do they handle the CANCEL?  Am I missing 
>>something obvious? 
>
>Is there any reason why the stateless proxy would do something 
>other than forward the CANCEL request? I don't understand 
>what the alternative might be. 

I agree. The stateless proxy will re-apply its routing logic and forward the
request downstream. You might run into problems if the stateless proxy is
trying to do some statistical load balancing, and sends the CANCEL a
different place than INVITE. For this reason, stateless proxies, in general,
should really only apply routing which is deterministic, that is, for which
the routing decision is dependent only on a static function where the only
input is the SIP reuqest, and possibly some static configuration data. If
you don't do this, you will also have troubles with retransmissions going
different places.

-Jonathan R.

---
Jonathan D. Rosenberg                       72 Eagle Rock Ave.
Chief Scientist                             First Floor
dynamicsoft                                 East Hanover, NJ 07936
[email-masked]                     FAX:   (973) 952-5050
http://www.jdrosen.net                      PHONE: (973) 952-5000
http://www.dynamicsoft.com

_______________________________________________
This list is for continuing development of the SIP protocol.
The sip-implementor's list is the place to discuss implementation,
and to receive advice on understanding existing sip.
To subscribe to it, send mail to 
[email-masked] with "subscribe" in the body.

---

From: Vijay Gurbani <[email-masked]>
Date: Fri, 27 Apr 2001 09:36:15 -0500

Jonathan Rosenberg wrote:
[...]
> vkg>> Oh, that brings up an interesting point:   If a stateful proxy
> vkg>> forked and one of the branches reached a stateless downstream
> vkg>> server, when the statful proxy gets a CANCEL, it will propogate the 
> vkg>> CANCEL to the state-=less downstream proxy.  What do statless 
> vkg>> proxies do on getting a CANCEL?
> vkg>> Since they do not have state associated with the INVITE they 
> vkg>> received earlier, how do they handle the CANCEL?  Am I missing
> vkg>> something obvious?
> >
> sean>Is there any reason why the stateless proxy would do something
> sean>other than forward the CANCEL request? I don't understand
> sean>what the alternative might be.
> 
jdr> I agree. The stateless proxy will re-apply its routing logic and 
jdr> forward the request downstream. 

Yes, that's probably the case.  It is just that CANCEL is usually associated
with hop-by-hop behavior, not end-to-end.  So it seemed somehow funky that a 
stateless proxy will forward the CANCEL to the next downstream server. But 
of course, it cannot do anything else; it is stateless.

Thanks,

- vijay
-- 
Vijay K. Gurbani  vkg@{lucent.com,research.bell-labs.com,acm.org}
Internet Software and eServices Group 
Lucent Technologies/Bell Labs Innovations 263 Shuman Blvd., Rm 1A-413
Naperville, Illinois 60566     Voice: +1 630 224 0216   Fax: +1 630 713 0184